# This is truly horrific, but:
#   - this Helm chart is unsupported upstream and has no native backup support
#   - you can't just crash into an existing container and do it
#   - other solutions require sharing the persistent volume across multiple
#     claims, which upstream never got working despite trying
#   - it's better than running this from a non-K8s cronjob on a my workstation

apiVersion: batch/v1beta1
kind: CronJob
metadata:
  name: {{ template "fullname" . }}-backup
  labels:
    app: {{ template "fullname" . }}
    chart: "{{ .Chart.Name }}-{{ .Chart.Version }}"
    release: "{{ .Release.Name }}"
    heritage: "{{ .Release.Service }}"
spec:
  concurrencyPolicy: Forbid
  successfulJobsHistoryLimit: 20
  failedJobsHistoryLimit: 25
  # Time is server time (UTC)
  schedule: "00 04 * * *"
  jobTemplate:
    spec:
      template:
        spec:
          restartPolicy: Never
          containers:
          - name: kubectl
            image: lachlanevenson/k8s-kubectl:v1.10.0
            command:
            - /bin/sh
            - -c
            - pod_name=$(kubectl get pods -n default -o jsonpath='{.items[*].metadata.name}' -l name=gitlab-prod-gitlab --field-selector=status.phase=Running);
              kubectl get po/${pod_name};
              kubectl exec ${pod_name} -- gitlab-rake gitlab:backup:create SKIP=artifacts,registry,lfs,uploads;
              #kubectl exec ${pod_name} -- sh -c 'rm -f /gitlab-registry/*_gitlab_backup.tar'

